using System;
using System.Diagnostics.CodeAnalysis;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MSTestExtensions.Tests
{
    /// <remarks/>
    [TestClass]
    public class ExpectedExceptionMessageAttributeTest : MSTestExtensionsTestFixture
    {
        #region Unit Tests

        /// <remarks/>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA1303:DoNotPassLiteralsAsLocalizedParameters", MessageId = "MSTestExtensions.MSTestExtensionsException.#ctor(System.String)"), TestMethod]
        [ExpectedExceptionMessage(typeof(MSTestExtensionsException), "My expected exception message.")]
        public void TestInterceptionWithExpectedExceptionMessage()
        {
            throw new MSTestExtensionsException("My expected exception message.");
        }

        /// <remarks/>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA1303:DoNotPassLiteralsAsLocalizedParameters", MessageId = "MSTestExtensions.MSTestExtensionsException.#ctor(System.String)"), TestMethod]
        [ExpectedException(typeof(MSTestExtensionsException))]
        [ExpectedExceptionMessage(typeof(MSTestExtensionsException), "My expected exception message.")]
        public void TestInterceptionWithExpectedExceptionMessageFail()
        {
            throw new MSTestExtensionsException("My unexpected exception message.");
        }

        #endregion // Unit Tests
    }
}
